local waiters = {}
local waitTimer = {}
local destroyTimer = {}

function onPlayerWantTakeTaxi (player, _, pTaxi)
    if getElementData(player, "taxi:worker") == true then return end
	if waitTimer[player] and isTimer(waitTimer[player]) and waitTimer[player] ~= nil then
	    outputChatBox("Вы уже вызвали такси. Услуга доступна раз в 5 минут!", player, 255, 0, 0)
		return
	end
	outputChatBox("Ожидайте ответа...", player, 255, 0, 0)
	local x, y, z = getElementPosition(player)
	table.insert(waiters, {player, getZoneName(x, y, z, true)})
	waitTimer[player] = setTimer(
		function (player)
			killTimer(waitTimer[player])
		    waitTimer[player] = nil
		end, 5 * 60000, 1, player
	)
	
	for i, player in ipairs (getElementsByType("player")) do
	    if getElementData(player, "taxi:worker") ~= true or getElementData(player, "taxi:client") ~= false then
	    else
		    outputChatBox("Новый заказ! Нажмите 5 для просмотра", player, 0, 255, 0)
		end
	end
end
addCommandHandler("calltaxi", onPlayerWantTakeTaxi)

function onPlayerOpenGrid (player)
    triggerClientEvent(player, "createTaxistMenu", player, waiters)
end

function onPlayerStartWork (arg)
    if arg == "Уволиться" then
	    unbindKey(source, "5", "down", onPlayerOpenGrid)
		setElementData(source, "taxi:worker", false)
		
		local waiter = getElementData(source, "taxi:client")
		if isElement(waiter) then
			local blip = getElementData(source, "blip")
			destroyElement(blip)
			local blip = getElementData(waiter, "blip")
			destroyElement(blip)
		end
		setElementData(source, "taxi:client", false)
		outputChatBox("Вы уволились с работы Таксиста", source, 0, 255, 0)
		return
	end
	if getElementData(source, "taxi:worker") == true then return end
    local x, y, z = unpack(vehicles[math.random(1,#vehicles)])
	local vehicle = createVehicle(420, x, y, z)
	setVehicleTaxiLightOn ( vehicle, true )
	warpPedIntoVehicle(source, vehicle)
	setElementData(vehicle, "taxi", true)
	setElementData(source, "taxi:worker", true)
	setElementData(source, "taxi:client", false)
	bindKey(source, "5", "down", onPlayerOpenGrid)
	
	outputChatBox("Вы устроились на работу Таксиста", source, 0, 255, 0)
end
addEvent("onPlayerStartWork", true)
addEventHandler("onPlayerStartWork", getRootElement(), onPlayerStartWork)

function disableBlips (player, blip)
	for i, pElement in ipairs (getElementsByType("player")) do
		setElementVisibleTo ( blip, pElement, false )
	end
	if player ~= false then
		setElementVisibleTo ( blip, player, true )
	end
end

function updateWaiters (playerName)
    if getElementData(source, "taxi:client") ~= false then outputChatBox("У вас уже есть клиент, заберите сначала его!", source, 255, 0, 0) return end
    for i, pl in ipairs (waiters) do
		if getPlayerName(pl[1]) == playerName then
		    table.remove(waiters, i)
			
			local blip = createBlipAttachedTo(pl[1],41)
			disableBlips (source, blip)
			setElementData(source, "blip", blip)
			local blip = createBlipAttachedTo(source,41)
			disableBlips (pl[1], blip)
			setElementData(pl[1], "blip", blip)
			
			outputChatBox("Ваш заказ приняли, ожидайте Такси!", pl[1], 255, 0, 0)
			outputChatBox("Клиент отмечен на карте!", source, 255, 0, 0)
			setElementData(source, "taxi:client", pl[1])
		end
	end
	triggerClientEvent(source, "createTaxistMenu", source, waiters)
end
addEvent("updateWaiters", true)
addEventHandler("updateWaiters", getRootElement(), updateWaiters)

function onPlayerVehicleEnter (vehicle, seat)
    if seat == 0 then	
		if getElementData(vehicle, "taxi") == true and getElementData(source, "taxi:worker") == true then
		    if isTimer(destroyTimer[source]) then
			    killTimer(destroyTimer[source])
			end
		end
	elseif seat ~= 0 then
	    local occupant = getVehicleOccupant(vehicle)
		if getElementData(occupant, "taxi:client") ~= source and getElementData(vehicle, "taxi") == true then
		    setControlState(source, "enter_exit", true)
			outputChatBox("Ожидайте своего таксиста!", source, 255, 255, 255, true)
		elseif occupant and isElement(occupant) and getElementData(occupant, "taxi:client") == source and getElementData(vehicle, "taxi") == true then
		    --outputChatBox("[Таксист] Куда едем?", source, 255, 0, 0)
			triggerClientEvent(source, "createEditMenu", source)
		end
	end
end
addEventHandler("onPlayerVehicleEnter", getRootElement(), onPlayerVehicleEnter)

function givePlayerWork (text)
    local veh = getPedOccupiedVehicle(source)
	local occupant = getVehicleOccupant(veh)
	local money = math.random(130000, 150000)
	outputChatBox("Клиент: "..text, occupant, 0, 255, 0)
	outputChatBox("Клиент отдал вам "..money.." руб", occupant, 0, 255, 0)
	outputChatBox("Вы заплатили "..money.." руб", source, 0, 255, 0)
	givePlayerMoney(occupant, money)
    exports [ "urovni" ]:givePlayerXP(occupant, 1)
end
addEvent("givePlayerWork", true)
addEventHandler("givePlayerWork", getRootElement(), givePlayerWork)

function onPlayerVehicleExit (vehicle, seat)
    if seat == 0 then
        if getElementData(vehicle, "taxi") == true and getElementData(source, "taxi:worker") == true then
		    destroyTimer[source] = setTimer(
			    function (pl, veh)
				    destroyElement(veh)
					setElementData(source, "taxi:worker", false)
					local waiter = getElementData(pl, "taxi:client")
					if isElement(waiter) then
					local blip = getElementData(pl, "blip")
					destroyElement(blip)
					local blip = getElementData(waiter, "blip")
					destroyElement(blip)
					end
					outputChatBox("Ваш таксист уволился с работы!", waiter, 255, 0, 0)
					
					triggerEvent("onPlayerStartWork", pl, "Уволиться")
				end, 15000, 1, source, vehicle
			)
		end
	elseif seat ~= 0 then
	    local occupant = getVehicleOccupant(vehicle)
		if getElementData(occupant, "taxi:client") == source then
			outputChatBox("Спасибо за то, что используете наше такси!", source, 0, 255, 0)
		end
		setElementData(occupant, "taxi:client", false)
		
		local blip = getElementData(occupant, "blip")
		destroyElement(blip)
		local blip = getElementData(source, "blip")
		destroyElement(blip)
	end
end
addEventHandler("onPlayerVehicleExit", getRootElement(), onPlayerVehicleExit)

function onPlayerQuit ()
    local vehicle = getPedOccupiedVehicle(source)
	if vehicle then
	    if getElementData(source, "taxi:worker") == true and getElementData(vehicle, "taxi") == true then
			setElementData(source, "taxi:worker", false)
			local waiter = getElementData(vehicle, "taxi:client")
			if isElement(waiter) then
			    local blip = getElementData(source, "blip")
			    destroyElement(blip)
				local blip = getElementData(waiter, "blip")
				destroyElement(blip)
			end
			outputChatBox("Ваш таксист уволился с работы!", waiter, 255, 0, 0)
			destroyElement(vehicle)
		end
	end 
end
addEventHandler("onPlayerQuit", getRootElement(), onPlayerQuit)