local vehicleSelectionWindow = nil

local selectedVehicle = 1
local currentMarker = "Дальнобойщик"
local selectedRoute = 1
local routeStep = 1


function initVehicleSelecionWindow(mrk)
	if isElement(vehicleSelectionWindow) then
		destroyElement(vehicleSelectionWindow)
		showCursor(false)
	else
		currentMarker = mrk
		local screenW, screenH = guiGetScreenSize()
		vehicleSelectionWindow = guiCreateWindow((screenW - 489) / 2, (screenH - 334) / 2, 489, 334, "Выберите грузовик", false)
		image = guiCreateStaticImage(242, 30, 237, 236, ":DalnJob/drop.png", false, vehicleSelectionWindow)    
		showCursor(true)
		local grid = guiCreateGridList(9, 30, 233, 236, false, vehicleSelectionWindow)
		guiGridListAddColumn( grid, "Модель", 0.9 )
		for k,v in pairs(routesTable[currentMarker].Vehicles) do
			local row = guiGridListAddRow( grid )
			guiGridListSetItemText(grid,row,1,v[2],false,false)
			guiGridListSetItemData(grid,row,1,k)
		end

		local btn1 = guiCreateButton(267, 291, 199, 33, "Закрыть", false, vehicleSelectionWindow)
		local btn2 = guiCreateButton(33, 291, 199, 33, "Выбрать", false, vehicleSelectionWindow)
        guiSetFont(btn1, "default-bold-small")
		guiSetFont(btn2, "default-bold-small")
		addEventHandler("onClientGUIClick",vehicleSelectionWindow,function()
			if source == btn1 then
				initVehicleSelecionWindow()
			elseif source == btn2 then
				local selection = guiGridListGetSelectedItem( grid )
				if selection >= 0 then
					local key = guiGridListGetItemData(grid,selection,1)
					selectedVehicle = key
					initVehicleSelecionWindow()
					initRouteSelecionWindow()
				end
			end
		end)
	end
end
addEvent("initTruckWindow",true)
addEventHandler("initTruckWindow",root,initVehicleSelecionWindow)

function initRouteSelecionWindow()
	if isElement(vehicleSelectionWindow) then
		destroyElement(vehicleSelectionWindow)
		showCursor(false)
	else
		showCursor(true)
		local screenW, screenH = guiGetScreenSize()
		vehicleSelectionWindow = guiCreateWindow((screenW - 489) / 2, (screenH - 334) / 2, 489, 334, "Выберите маршрут", false)
		local grid = guiCreateGridList(0,0.1,1,0.7,true,vehicleSelectionWindow)
		guiGridListAddColumn( grid, "Название", 0.5 ) guiGridListAddColumn( grid, "Оплата", 0.4 )
		for k,v in pairs(routesTable[currentMarker].Routes) do
			local row = guiGridListAddRow( grid )
			guiGridListSetItemText(grid,row,1,v[1],false,false)
			local mul = routesTable[currentMarker]["Vehicles"][selectedVehicle][3]
			guiGridListSetItemText(grid,row,2,v[2]*mul,false,false)
			guiGridListSetItemData(grid,row,1,k) guiGridListSetItemData(grid,row,2,k)
		end

		local btn1 = guiCreateButton(267, 291, 199, 33, "Закрыть", false, vehicleSelectionWindow)
		local btn2 = guiCreateButton(33, 291, 199, 33, "Выбрать", false, vehicleSelectionWindow)

		addEventHandler("onClientGUIClick",vehicleSelectionWindow,function()
			if source == btn1 then
				initVehicleSelecionWindow()
			elseif source == btn2 then
				local selection = guiGridListGetSelectedItem( grid )
				if selection >= 0 then
					local key = guiGridListGetItemData(grid,selection,1)
					selectedRoute = key
					triggerServerEvent("truckStartRoute",localPlayer,selectedVehicle,currentMarker,key)
					local pos = routesTable[currentMarker]["Routes"][key][3]
					createRouteMarker(pos[1],pos[2],pos[3])
					routeStep = 1
					initVehicleSelecionWindow()
				end
			end
		end)
	end
end

local routeMarker = nil
local routeBlip = nil

function destroyRouteMarkers()
	if isElement(routeBlip) then destroyElement(routeBlip) end
	if isElement(routeMarker) then destroyElement(routeMarker) end
end
addEvent("destroyTruckMarkers",true)
addEventHandler("destroyTruckMarkers",root,destroyRouteMarkers)

function createRouteMarker(x,y,z)
	destroyRouteMarkers()
	routeMarker = createMarker(x,y,z,"cylinder",3,200,50,50)
	routeBlip = createBlipAttachedTo(routeMarker)
end

addEventHandler ( "onClientMarkerHit", getRootElement(), function(ply)
	if ply ~= localPlayer then return end
	if not isPedInVehicle(ply) then return end
	if source ~= routeMarker then return end
	if routeStep == 1 then
		routeStep = 2
		destroyRouteMarkers()
		outputChatBox(routesTable[currentMarker].Msg2,200,200,200)
		setElementFrozen(getPedOccupiedVehicle( localPlayer ), true)
		setTimer(function() 
			setElementFrozen(getPedOccupiedVehicle(localPlayer),false)
			outputChatBox(routesTable[currentMarker].Msg3,50,200,50)
			local pos = routesTable[currentMarker].DestinationPoint
			createRouteMarker(pos[1],pos[2],pos[3])
		end,30000,1)
	elseif routeStep == 2 then
		triggerServerEvent( "truckEndRoute", localPlayer )
	end
end)
